Attribute VB_Name = "ModHMap"
Type GridStruct
    SqValue() As String
    Walkable() As Boolean
    Special() As Boolean
End Type

Dim Grids() As GridStruct

Dim TmpInt As Integer
    
Function ParseGrid(FName As String, FlatId As Integer)
    Dim FileCont As String
    Dim FlatSplit As Variant
    Dim XC As Integer
    Dim YC As Integer
    Dim X As Integer
    Dim Y As Integer
    
    FileCont = Trim(fso.OpenTextFile(FName, ForReading).ReadAll)
    FlatSplit = Split(FileCont, " ")
    XC = Len(FlatSplit(0))
    YC = UBound(FlatSplit)
    ReDim Grids(FlatId).SqValue(0 To XC, 0 To YC)
    ReDim Grids(FlatId).Walkable(0 To XC, 0 To YC)
    ReDim Grids(FlatId).Special(0 To XC, 0 To YC)
    
    For X = 0 To XC - 1
        For Y = 0 To YC
            'Debug.Print X & "," & Y & " = "; Mid(FlatSplit(Y), X + 1, 1)
            Call AssignToArray(X, Y, Mid(FlatSplit(Y), X + 1, 1), FlatId)
            DoEvents
        Next
    Next
End Function

Function AssignToArray(X As Integer, Y As Integer, Value As String, FlatId As Integer)
    Grids(FlatId).SqValue(X, Y) = Value
    
    If Value = "x" Then 'Blocking
        Grids(FlatId).Walkable(X, Y) = False
        Grids(FlatId).Special(X, Y) = False
        'Debug.Print X & "," & Y & " = " & Value & " (Blocking)"
    ElseIf Value = "y" Then 'Object
        Grids(FlatId).Walkable(X, Y) = False
        Grids(FlatId).Special(X, Y) = False
        'Debug.Print X & "," & Y & " = " & Value & " (Object)"
    ElseIf Value = "A" Then 'Seat
        Grids(FlatId).Walkable(X, Y) = False
        Grids(FlatId).Special(X, Y) = True
        'Debug.Print X & "," & Y & " = " & Value & " (Seat)"
    ElseIf IsNumeric(Value) = True Then 'Blank
        Grids(FlatId).Walkable(X, Y) = True
        Grids(FlatId).Special(X, Y) = False
        'Debug.Print X & "," & Y & " = " & Value & " (Blank)"
    End If
        
    
End Function

Function LoadGrids()
Dim BreakLoop As Boolean
TmpInt = 0
    Do
        TmpInt = TmpInt + 1
        If fso.FileExists(App.Path & "\FLATFILES\" & TmpInt & "\HEIGHTMAP.TXT") = True Then
            ReDim Grids(TmpInt) As GridStruct
            Call ParseGrid(App.Path & "\FLATFILES\" & TmpInt & "\HEIGHTMAP.TXT", TmpInt)
        Else
            BreakLoop = True
        End If
    Loop Until BreakLoop = True
End Function
